package reader.structure;

import java.awt.Color;

public class Block implements Comparable {
	private BlockType blockType;

	private Thread thread;

	private long begin;

	private long end;

	public Block(BlockType blockType, long begin, long end) {
		super();
		this.blockType = blockType;
		this.begin = begin;
		this.end = end;
	}

	public BlockType getBlockType() {
		return this.blockType;
	}

	public Thread getThread() {
		return thread;
	}

	public void setThread(Thread thread) {
		this.thread = thread;
	}

	public long getBegin() {
		return this.begin;
	}

	public long getEnd() {
		return this.end;
	}

	public long getDuration() {
		return this.end - this.begin;
	}

	public void setBegin(long begin) {
		long difference = begin - this.begin;
		this.begin = begin;
		this.end += difference;
	}

	public int compareTo(Object o) {
		if (o instanceof Block) {
			Block other = (Block) o;
			return new Long(this.begin).compareTo(new Long(other.getBegin()));
		} else {
			return 0;
		}
	}
	
	public Color getColor(){
		if(this.blockType == BlockType.CODE){
			return Color.GREEN;
		}else if(this.blockType == BlockType.MUTEX){
			return Color.YELLOW;
		}else {
			return Color.RED;
		}
	}
}